# coding: utf-8

"""
    Marqeta Core API

    Simplified management of your payment programs  # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, StrictStr, validator

class AccountFunding(BaseModel):
    """
    AccountFunding
    """
    transaction_type: Optional[StrictStr] = None
    funding_source: Optional[StrictStr] = None
    receiver_account_type: Optional[StrictStr] = None
    receiver_name: Optional[StrictStr] = None
    screening_score: Optional[StrictStr] = None
    transaction_purpose: Optional[StrictStr] = None
    __properties = ["transaction_type", "funding_source", "receiver_account_type", "receiver_name", "screening_score", "transaction_purpose"]

    @validator('transaction_type')
    def transaction_type_validate_enum(cls, v):
        if v is None:
            return v

        if v not in ('ACCOUNT_TO_ACCOUNT', 'PERSON_TO_PERSON', 'WALLET_TRANSFER', 'MONEY_TRANSFER_BY_BANK', 'BUSINESS_TO_BUSINESS', 'DISBURSEMENT', 'GOVERNMENT_DISBURSEMENT', 'GAMBLING_PAYOUT', 'LOYALTY', 'MERCHANT_DISBURSEMENT', 'ONLINE_GAMBLING_PAYOUT', 'PENSION_DISBURSEMENT', 'PREPAID_LOADS', 'CARD_BILL_PAYMENT', 'BILL_PAYMENT', 'CASH_CLAIM', 'CASH_IN', 'CASH_OUT', 'MOBILE_AIR_TIME_PAYMENT', 'MONEY_TRANSFER_BY_MERCHANT', 'FACE_TO_FACE_MERCHANT_PAYMENT', 'GOVERNMENT_PAYMENT', 'PAYMENTS_GOODS_SERVICES', 'FUNDS_TRANSFER', 'GENERAL_BUSINESS_TO_BUSINESS_TRANSFER', 'BUSINESS_TO_BUSINESS_TRANSFER', 'CASH_DEPOSIT'):
            raise ValueError("must be one of enum values ('ACCOUNT_TO_ACCOUNT', 'PERSON_TO_PERSON', 'WALLET_TRANSFER', 'MONEY_TRANSFER_BY_BANK', 'BUSINESS_TO_BUSINESS', 'DISBURSEMENT', 'GOVERNMENT_DISBURSEMENT', 'GAMBLING_PAYOUT', 'LOYALTY', 'MERCHANT_DISBURSEMENT', 'ONLINE_GAMBLING_PAYOUT', 'PENSION_DISBURSEMENT', 'PREPAID_LOADS', 'CARD_BILL_PAYMENT', 'BILL_PAYMENT', 'CASH_CLAIM', 'CASH_IN', 'CASH_OUT', 'MOBILE_AIR_TIME_PAYMENT', 'MONEY_TRANSFER_BY_MERCHANT', 'FACE_TO_FACE_MERCHANT_PAYMENT', 'GOVERNMENT_PAYMENT', 'PAYMENTS_GOODS_SERVICES', 'FUNDS_TRANSFER', 'GENERAL_BUSINESS_TO_BUSINESS_TRANSFER', 'BUSINESS_TO_BUSINESS_TRANSFER', 'CASH_DEPOSIT')")
        return v

    @validator('funding_source')
    def funding_source_validate_enum(cls, v):
        if v is None:
            return v

        if v not in ('CREDIT', 'DEBIT', 'PREPAID', 'DEPOSIT_ACCOUNT', 'CASH', 'MOBILE_MONEY_ACCOUNT', 'NON_VISA_CREDIT'):
            raise ValueError("must be one of enum values ('CREDIT', 'DEBIT', 'PREPAID', 'DEPOSIT_ACCOUNT', 'CASH', 'MOBILE_MONEY_ACCOUNT', 'NON_VISA_CREDIT')")
        return v

    @validator('receiver_account_type')
    def receiver_account_type_validate_enum(cls, v):
        if v is None:
            return v

        if v not in ('OTHER', 'RTN_BANK_ACCOUNT', 'IBAN', 'CARD_ACCOUNT', 'EMAIL', 'PHONE_NUMBER', 'BANK_ACCOUNT_NUMBER_AND_BANK_IDENTIFICATION_CODE', 'WALLET_ID', 'SOCIAL_NETWORK_ID'):
            raise ValueError("must be one of enum values ('OTHER', 'RTN_BANK_ACCOUNT', 'IBAN', 'CARD_ACCOUNT', 'EMAIL', 'PHONE_NUMBER', 'BANK_ACCOUNT_NUMBER_AND_BANK_IDENTIFICATION_CODE', 'WALLET_ID', 'SOCIAL_NETWORK_ID')")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AccountFunding:
        """Create an instance of AccountFunding from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AccountFunding:
        """Create an instance of AccountFunding from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return AccountFunding.parse_obj(obj)

        _obj = AccountFunding.parse_obj({
            "transaction_type": obj.get("transaction_type"),
            "funding_source": obj.get("funding_source"),
            "receiver_account_type": obj.get("receiver_account_type"),
            "receiver_name": obj.get("receiver_name"),
            "screening_score": obj.get("screening_score"),
            "transaction_purpose": obj.get("transaction_purpose")
        })
        return _obj

