# coding: utf-8

"""
    Marqeta Core API

    Simplified management of your payment programs  # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, StrictBool, constr
from marqeta_client.models.merchant_scope import MerchantScope
from marqeta_client.models.spend_control_association import SpendControlAssociation

class AuthControlUpdateRequest(BaseModel):
    """
    AuthControlUpdateRequest
    """
    token: constr(strict=True, max_length=36, min_length=1) = ...
    name: Optional[constr(strict=True, max_length=255, min_length=0)] = None
    association: Optional[SpendControlAssociation] = None
    merchant_scope: Optional[MerchantScope] = None
    start_time: Optional[datetime] = None
    end_time: Optional[datetime] = None
    active: Optional[StrictBool] = True
    __properties = ["token", "name", "association", "merchant_scope", "start_time", "end_time", "active"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AuthControlUpdateRequest:
        """Create an instance of AuthControlUpdateRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of association
        if self.association:
            _dict['association'] = self.association.to_dict()
        # override the default output from pydantic by calling `to_dict()` of merchant_scope
        if self.merchant_scope:
            _dict['merchant_scope'] = self.merchant_scope.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AuthControlUpdateRequest:
        """Create an instance of AuthControlUpdateRequest from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return AuthControlUpdateRequest.parse_obj(obj)

        _obj = AuthControlUpdateRequest.parse_obj({
            "token": obj.get("token"),
            "name": obj.get("name"),
            "association": SpendControlAssociation.from_dict(obj.get("association")) if obj.get("association") is not None else None,
            "merchant_scope": MerchantScope.from_dict(obj.get("merchant_scope")) if obj.get("merchant_scope") is not None else None,
            "start_time": obj.get("start_time"),
            "end_time": obj.get("end_time"),
            "active": obj.get("active") if obj.get("active") is not None else True
        })
        return _obj

