# coding: utf-8

"""
    Marqeta Core API

    Simplified management of your payment programs  # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import List, Optional, Union
from pydantic import BaseModel, StrictBool, StrictFloat, StrictInt, conlist, constr
from marqeta_client.models.card_acceptor_model import CardAcceptorModel
from marqeta_client.models.card_options import CardOptions
from marqeta_client.models.network_fee_model import NetworkFeeModel
from marqeta_client.models.network_metadata import NetworkMetadata
from marqeta_client.models.transaction_options import TransactionOptions
from marqeta_client.models.webhook import Webhook

class AuthRequestModel(BaseModel):
    """
    AuthRequestModel
    """
    network_fees: Optional[conlist(NetworkFeeModel)] = None
    webhook: Optional[Webhook] = None
    card_token: constr(strict=True, max_length=36, min_length=1) = ...
    amount: Union[StrictFloat, StrictInt] = ...
    cash_back_amount: Optional[Union[StrictFloat, StrictInt]] = None
    mid: constr(strict=True, max_length=50, min_length=1) = ...
    is_pre_auth: Optional[StrictBool] = False
    pin: Optional[constr(strict=True, max_length=50, min_length=1)] = None
    card_options: Optional[CardOptions] = None
    card_acceptor: Optional[CardAcceptorModel] = None
    transaction_options: Optional[TransactionOptions] = None
    network_metadata: Optional[NetworkMetadata] = None
    __properties = ["network_fees", "webhook", "card_token", "amount", "cash_back_amount", "mid", "is_pre_auth", "pin", "card_options", "card_acceptor", "transaction_options", "network_metadata"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AuthRequestModel:
        """Create an instance of AuthRequestModel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in network_fees (list)
        _items = []
        if self.network_fees:
            for _item in self.network_fees:
                if _item:
                    _items.append(_item.to_dict())
            _dict['network_fees'] = _items
        # override the default output from pydantic by calling `to_dict()` of webhook
        if self.webhook:
            _dict['webhook'] = self.webhook.to_dict()
        # override the default output from pydantic by calling `to_dict()` of card_options
        if self.card_options:
            _dict['card_options'] = self.card_options.to_dict()
        # override the default output from pydantic by calling `to_dict()` of card_acceptor
        if self.card_acceptor:
            _dict['card_acceptor'] = self.card_acceptor.to_dict()
        # override the default output from pydantic by calling `to_dict()` of transaction_options
        if self.transaction_options:
            _dict['transaction_options'] = self.transaction_options.to_dict()
        # override the default output from pydantic by calling `to_dict()` of network_metadata
        if self.network_metadata:
            _dict['network_metadata'] = self.network_metadata.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AuthRequestModel:
        """Create an instance of AuthRequestModel from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return AuthRequestModel.parse_obj(obj)

        _obj = AuthRequestModel.parse_obj({
            "network_fees": [NetworkFeeModel.from_dict(_item) for _item in obj.get("network_fees")] if obj.get("network_fees") is not None else None,
            "webhook": Webhook.from_dict(obj.get("webhook")) if obj.get("webhook") is not None else None,
            "card_token": obj.get("card_token"),
            "amount": obj.get("amount"),
            "cash_back_amount": obj.get("cash_back_amount"),
            "mid": obj.get("mid"),
            "is_pre_auth": obj.get("is_pre_auth") if obj.get("is_pre_auth") is not None else False,
            "pin": obj.get("pin"),
            "card_options": CardOptions.from_dict(obj.get("card_options")) if obj.get("card_options") is not None else None,
            "card_acceptor": CardAcceptorModel.from_dict(obj.get("card_acceptor")) if obj.get("card_acceptor") is not None else None,
            "transaction_options": TransactionOptions.from_dict(obj.get("transaction_options")) if obj.get("transaction_options") is not None else None,
            "network_metadata": NetworkMetadata.from_dict(obj.get("network_metadata")) if obj.get("network_metadata") is not None else None
        })
        return _obj

