# coding: utf-8

"""
    Marqeta Core API

    Simplified management of your payment programs  # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, StrictBool, StrictInt
from marqeta_client.models.expiration_offset import ExpirationOffset

class CardLifeCycle(BaseModel):
    """
    CardLifeCycle
    """
    activate_upon_issue: Optional[StrictBool] = False
    expiration_offset: Optional[ExpirationOffset] = None
    card_service_code: Optional[StrictInt] = 101
    update_expiration_upon_activation: Optional[StrictBool] = False
    __properties = ["activate_upon_issue", "expiration_offset", "card_service_code", "update_expiration_upon_activation"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CardLifeCycle:
        """Create an instance of CardLifeCycle from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of expiration_offset
        if self.expiration_offset:
            _dict['expiration_offset'] = self.expiration_offset.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CardLifeCycle:
        """Create an instance of CardLifeCycle from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return CardLifeCycle.parse_obj(obj)

        _obj = CardLifeCycle.parse_obj({
            "activate_upon_issue": obj.get("activate_upon_issue") if obj.get("activate_upon_issue") is not None else False,
            "expiration_offset": ExpirationOffset.from_dict(obj.get("expiration_offset")) if obj.get("expiration_offset") is not None else None,
            "card_service_code": obj.get("card_service_code") if obj.get("card_service_code") is not None else 101,
            "update_expiration_upon_activation": obj.get("update_expiration_upon_activation") if obj.get("update_expiration_upon_activation") is not None else False
        })
        return _obj

