# coding: utf-8

"""
    Marqeta Core API

    Simplified management of your payment programs  # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional
from pydantic import BaseModel, Field, StrictBool, constr
from marqeta_client.models.card_product_config import CardProductConfig

class CardProductRequest(BaseModel):
    """
    CardProductRequest
    """
    token: Optional[constr(strict=True, max_length=36, min_length=1)] = None
    name: constr(strict=True, max_length=40, min_length=1) = ...
    active: Optional[StrictBool] = False
    start_date: date = Field(..., description="yyyy-MM-dd")
    end_date: Optional[date] = Field(None, description="yyyy-MM-dd")
    config: Optional[CardProductConfig] = None
    __properties = ["token", "name", "active", "start_date", "end_date", "config"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CardProductRequest:
        """Create an instance of CardProductRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of config
        if self.config:
            _dict['config'] = self.config.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CardProductRequest:
        """Create an instance of CardProductRequest from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return CardProductRequest.parse_obj(obj)

        _obj = CardProductRequest.parse_obj({
            "token": obj.get("token"),
            "name": obj.get("name"),
            "active": obj.get("active") if obj.get("active") is not None else False,
            "start_date": obj.get("start_date"),
            "end_date": obj.get("end_date"),
            "config": CardProductConfig.from_dict(obj.get("config")) if obj.get("config") is not None else None
        })
        return _obj

