# coding: utf-8

"""
    Marqeta Core API

    Simplified management of your payment programs  # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, constr, validator

class CardReorderRequest(BaseModel):
    """
    CardReorderRequest
    """
    card_batch_label: Optional[constr(strict=True, max_length=50, min_length=1)] = Field(None, description="May only contain alphanumeric, hyphens, and underscore characters")
    __properties = ["card_batch_label"]

    @validator('card_batch_label')
    def card_batch_label_validate_regular_expression(cls, v):
        if v is None:
            return v

        if not re.match(r"^[\w-]*$", v):
            raise ValueError(r"must validate the regular expression /^[\w-]*$/")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CardReorderRequest:
        """Create an instance of CardReorderRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CardReorderRequest:
        """Create an instance of CardReorderRequest from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return CardReorderRequest.parse_obj(obj)

        _obj = CardReorderRequest.parse_obj({
            "card_batch_label": obj.get("card_batch_label")
        })
        return _obj

