# coding: utf-8

"""
    Marqeta Core API

    Simplified management of your payment programs  # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictBool, constr

class CardholderAddressResponse(BaseModel):
    """
    CardholderAddressResponse
    """
    user_token: Optional[constr(strict=True, max_length=36, min_length=1)] = Field(None, description="Required if 'business_token' is not specified")
    business_token: Optional[constr(strict=True, max_length=36, min_length=1)] = Field(None, description="Required if 'user_token' is not specified")
    token: constr(strict=True, max_length=36, min_length=1) = ...
    first_name: constr(strict=True, max_length=40, min_length=0) = ...
    last_name: constr(strict=True, max_length=40, min_length=0) = ...
    address_1: constr(strict=True, max_length=255, min_length=0) = ...
    address_2: Optional[constr(strict=True, max_length=255, min_length=0)] = None
    city: constr(strict=True, max_length=40, min_length=0) = ...
    state: constr(strict=True, max_length=2, min_length=0) = ...
    zip: constr(strict=True, max_length=10, min_length=0) = ...
    postal_code: constr(strict=True, max_length=10, min_length=0) = ...
    country: constr(strict=True, max_length=40, min_length=1) = ...
    phone: Optional[constr(strict=True, max_length=255, min_length=0)] = None
    is_default_address: Optional[StrictBool] = False
    active: Optional[StrictBool] = False
    created_time: datetime = Field(..., description="yyyy-MM-ddTHH:mm:ssZ")
    last_modified_time: datetime = Field(..., description="yyyy-MM-ddTHH:mm:ssZ")
    __properties = ["user_token", "business_token", "token", "first_name", "last_name", "address_1", "address_2", "city", "state", "zip", "postal_code", "country", "phone", "is_default_address", "active", "created_time", "last_modified_time"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CardholderAddressResponse:
        """Create an instance of CardholderAddressResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CardholderAddressResponse:
        """Create an instance of CardholderAddressResponse from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return CardholderAddressResponse.parse_obj(obj)

        _obj = CardholderAddressResponse.parse_obj({
            "user_token": obj.get("user_token"),
            "business_token": obj.get("business_token"),
            "token": obj.get("token"),
            "first_name": obj.get("first_name"),
            "last_name": obj.get("last_name"),
            "address_1": obj.get("address_1"),
            "address_2": obj.get("address_2"),
            "city": obj.get("city"),
            "state": obj.get("state"),
            "zip": obj.get("zip"),
            "postal_code": obj.get("postal_code"),
            "country": obj.get("country"),
            "phone": obj.get("phone"),
            "is_default_address": obj.get("is_default_address") if obj.get("is_default_address") is not None else False,
            "active": obj.get("active") if obj.get("active") is not None else False,
            "created_time": obj.get("created_time"),
            "last_modified_time": obj.get("last_modified_time")
        })
        return _obj

