# coding: utf-8

"""
    Marqeta Core API

    Simplified management of your payment programs  # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr, validator

class ClearingAndSettlement(BaseModel):
    """
    ClearingAndSettlement
    """
    overdraft_destination: Optional[StrictStr] = Field('GPA', description="Default value of GPA does not apply when JIT funding is enabled")
    __properties = ["overdraft_destination"]

    @validator('overdraft_destination')
    def overdraft_destination_validate_enum(cls, v):
        if v is None:
            return v

        if v not in ('GPA', 'MSA', 'MERCHANT_CAMPAIGN_ACCOUNT', 'GLOBAL_OVERDRAFT_ACCOUNT'):
            raise ValueError("must be one of enum values ('GPA', 'MSA', 'MERCHANT_CAMPAIGN_ACCOUNT', 'GLOBAL_OVERDRAFT_ACCOUNT')")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ClearingAndSettlement:
        """Create an instance of ClearingAndSettlement from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ClearingAndSettlement:
        """Create an instance of ClearingAndSettlement from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return ClearingAndSettlement.parse_obj(obj)

        _obj = ClearingAndSettlement.parse_obj({
            "overdraft_destination": obj.get("overdraft_destination") if obj.get("overdraft_destination") is not None else 'GPA'
        })
        return _obj

