# coding: utf-8

"""
    Marqeta Core API

    Simplified management of your payment programs  # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, StrictStr, constr, validator
from marqeta_client.models.card_swap_hash import CardSwapHash
from marqeta_client.models.digital_wallet_token_hash import DigitalWalletTokenHash

class DigitalWalletTokenTransitionResponse(BaseModel):
    """
    DigitalWalletTokenTransitionResponse
    """
    token: constr(strict=True, max_length=36, min_length=1) = ...
    digital_wallet_token: DigitalWalletTokenHash = ...
    card_swap: Optional[CardSwapHash] = None
    type: constr(strict=True, max_length=36, min_length=0) = ...
    channel: StrictStr = ...
    state: StrictStr = ...
    fulfillment_status: StrictStr = ...
    reason: Optional[constr(strict=True, max_length=255, min_length=0)] = None
    reason_code: Optional[StrictStr] = None
    created_time: Optional[datetime] = None
    __properties = ["token", "digital_wallet_token", "card_swap", "type", "channel", "state", "fulfillment_status", "reason", "reason_code", "created_time"]

    @validator('channel')
    def channel_validate_enum(cls, v):
        if v not in ('TOKEN_SERVICE_PROVIDER', 'DIGITAL_WALLET', 'API', 'IVR', 'FRAUD', 'ADMIN', 'SYSTEM', 'TOKEN_SERVICE_PROVIDER_API'):
            raise ValueError("must be one of enum values ('TOKEN_SERVICE_PROVIDER', 'DIGITAL_WALLET', 'API', 'IVR', 'FRAUD', 'ADMIN', 'SYSTEM', 'TOKEN_SERVICE_PROVIDER_API')")
        return v

    @validator('state')
    def state_validate_enum(cls, v):
        if v not in ('REQUESTED', 'REQUEST_DECLINED', 'ACTIVE', 'SUSPENDED', 'TERMINATED'):
            raise ValueError("must be one of enum values ('REQUESTED', 'REQUEST_DECLINED', 'ACTIVE', 'SUSPENDED', 'TERMINATED')")
        return v

    @validator('fulfillment_status')
    def fulfillment_status_validate_enum(cls, v):
        if v not in ('DECISION_RED', 'DECISION_YELLOW', 'DECISION_GREEN', 'REJECTED', 'PROVISIONED'):
            raise ValueError("must be one of enum values ('DECISION_RED', 'DECISION_YELLOW', 'DECISION_GREEN', 'REJECTED', 'PROVISIONED')")
        return v

    @validator('reason_code')
    def reason_code_validate_enum(cls, v):
        if v is None:
            return v

        if v not in ('00', '01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23', '24', '25', '26', '27', '28', '29', '30', '31'):
            raise ValueError("must be one of enum values ('00', '01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23', '24', '25', '26', '27', '28', '29', '30', '31')")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DigitalWalletTokenTransitionResponse:
        """Create an instance of DigitalWalletTokenTransitionResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "type",
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of digital_wallet_token
        if self.digital_wallet_token:
            _dict['digital_wallet_token'] = self.digital_wallet_token.to_dict()
        # override the default output from pydantic by calling `to_dict()` of card_swap
        if self.card_swap:
            _dict['card_swap'] = self.card_swap.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DigitalWalletTokenTransitionResponse:
        """Create an instance of DigitalWalletTokenTransitionResponse from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return DigitalWalletTokenTransitionResponse.parse_obj(obj)

        _obj = DigitalWalletTokenTransitionResponse.parse_obj({
            "token": obj.get("token"),
            "digital_wallet_token": DigitalWalletTokenHash.from_dict(obj.get("digital_wallet_token")) if obj.get("digital_wallet_token") is not None else None,
            "card_swap": CardSwapHash.from_dict(obj.get("card_swap")) if obj.get("card_swap") is not None else None,
            "type": obj.get("type"),
            "channel": obj.get("channel"),
            "state": obj.get("state"),
            "fulfillment_status": obj.get("fulfillment_status"),
            "reason": obj.get("reason"),
            "reason_code": obj.get("reason_code"),
            "created_time": obj.get("created_time")
        })
        return _obj

