# coding: utf-8

"""
    Marqeta Core API

    Simplified management of your payment programs  # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist, constr, validator
from marqeta_client.models.customer_due_diligence_request import CustomerDueDiligenceRequest

class DirectDepositAccountRequest(BaseModel):
    """
    DirectDepositAccountRequest
    """
    token: Optional[StrictStr] = None
    user_token: Optional[constr(strict=True, max_length=36, min_length=1)] = Field(None, description="Required if 'business_token' is null")
    business_token: Optional[constr(strict=True, max_length=36, min_length=1)] = Field(None, description="Required if 'user_token' is null")
    type: Optional[StrictStr] = None
    allow_immediate_credit: Optional[StrictBool] = False
    customer_due_diligence: Optional[conlist(CustomerDueDiligenceRequest)] = Field(None, description="Required if account type = Checking")
    __properties = ["token", "user_token", "business_token", "type", "allow_immediate_credit", "customer_due_diligence"]

    @validator('type')
    def type_validate_enum(cls, v):
        if v is None:
            return v

        if v not in ('DEPOSIT_ACCOUNT', 'CHECKING', 'SAVINGS', 'HIGH_YIELD'):
            raise ValueError("must be one of enum values ('DEPOSIT_ACCOUNT', 'CHECKING', 'SAVINGS', 'HIGH_YIELD')")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DirectDepositAccountRequest:
        """Create an instance of DirectDepositAccountRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in customer_due_diligence (list)
        _items = []
        if self.customer_due_diligence:
            for _item in self.customer_due_diligence:
                if _item:
                    _items.append(_item.to_dict())
            _dict['customer_due_diligence'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DirectDepositAccountRequest:
        """Create an instance of DirectDepositAccountRequest from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return DirectDepositAccountRequest.parse_obj(obj)

        _obj = DirectDepositAccountRequest.parse_obj({
            "token": obj.get("token"),
            "user_token": obj.get("user_token"),
            "business_token": obj.get("business_token"),
            "type": obj.get("type"),
            "allow_immediate_credit": obj.get("allow_immediate_credit") if obj.get("allow_immediate_credit") is not None else False,
            "customer_due_diligence": [CustomerDueDiligenceRequest.from_dict(_item) for _item in obj.get("customer_due_diligence")] if obj.get("customer_due_diligence") is not None else None
        })
        return _obj

