# coding: utf-8

"""
    Marqeta Core API

    Simplified management of your payment programs  # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Dict, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, constr

class GatewayProgramFundingSourceResponse(BaseModel):
    """
    GatewayProgramFundingSourceResponse
    """
    url: StrictStr = Field(..., description="250 char max. Empty string (disabled). Must be HTTPS.")
    version: StrictStr = ...
    name: constr(strict=True, max_length=50, min_length=1) = ...
    active: Optional[StrictBool] = None
    token: constr(strict=True, max_length=36, min_length=1) = ...
    created_time: datetime = ...
    last_modified_time: datetime = ...
    account: StrictStr = ...
    basic_auth_username: StrictStr = Field(..., description="50 char max. Required if URL is present")
    basic_auth_password: StrictStr = Field(..., description="50 char max. Required if URL is present. Minimum 20 chars with upper and lowercase letters, numbers, and symbols")
    timeout_millis: StrictInt = Field(..., description="Total timeout in milliseconds for gateway processing")
    custom_header: Dict[str, StrictStr] = Field(..., description="Custom headers to be passed along with request")
    use_mtls: StrictBool = Field(..., description="Use MTLS for funding request")
    __properties = ["url", "version", "name", "active", "token", "created_time", "last_modified_time", "account", "basic_auth_username", "basic_auth_password", "timeout_millis", "custom_header", "use_mtls"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GatewayProgramFundingSourceResponse:
        """Create an instance of GatewayProgramFundingSourceResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GatewayProgramFundingSourceResponse:
        """Create an instance of GatewayProgramFundingSourceResponse from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return GatewayProgramFundingSourceResponse.parse_obj(obj)

        _obj = GatewayProgramFundingSourceResponse.parse_obj({
            "url": obj.get("url"),
            "version": obj.get("version"),
            "name": obj.get("name"),
            "active": obj.get("active"),
            "token": obj.get("token"),
            "created_time": obj.get("created_time"),
            "last_modified_time": obj.get("last_modified_time"),
            "account": obj.get("account"),
            "basic_auth_username": obj.get("basic_auth_username"),
            "basic_auth_password": obj.get("basic_auth_password"),
            "timeout_millis": obj.get("timeout_millis"),
            "custom_header": obj.get("custom_header"),
            "use_mtls": obj.get("use_mtls") if obj.get("use_mtls") is not None else False
        })
        return _obj

