# coding: utf-8

"""
    Marqeta Core API

    Simplified management of your payment programs  # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, StrictFloat, StrictInt, StrictStr, validator

class GLEntry(BaseModel):
    """
    GLEntry
    """
    detail: Optional[StrictStr] = None
    tag: Optional[StrictStr] = None
    amount: Union[StrictFloat, StrictInt] = ...
    layer: StrictStr = ...
    account: StrictStr = ...
    type: StrictStr = ...
    __properties = ["detail", "tag", "amount", "layer", "account", "type"]

    @validator('type')
    def type_validate_enum(cls, v):
        if v not in ('CREDIT', 'DEBIT'):
            raise ValueError("must be one of enum values ('CREDIT', 'DEBIT')")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GLEntry:
        """Create an instance of GLEntry from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GLEntry:
        """Create an instance of GLEntry from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return GLEntry.parse_obj(obj)

        _obj = GLEntry.parse_obj({
            "detail": obj.get("detail"),
            "tag": obj.get("tag"),
            "amount": obj.get("amount"),
            "layer": obj.get("layer"),
            "account": obj.get("account"),
            "type": obj.get("type")
        })
        return _obj

