# coding: utf-8

"""
    Marqeta Core API

    Simplified management of your payment programs  # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, StrictInt, StrictStr, conlist
from marqeta_client.models.riskcontrol_tags import RiskcontrolTags
from marqeta_client.models.triggered_rule import TriggeredRule

class IssuerFraudView(BaseModel):
    """
    IssuerFraudView
    """
    score: Optional[StrictInt] = None
    risk_level: Optional[StrictStr] = None
    rule_violations: Optional[conlist(StrictStr)] = None
    recommended_action: Optional[StrictStr] = None
    riskcontrol_tags: Optional[conlist(RiskcontrolTags)] = None
    fraud_score_reasons: Optional[conlist(StrictStr)] = None
    triggered_rules: Optional[conlist(TriggeredRule)] = None
    __properties = ["score", "risk_level", "rule_violations", "recommended_action", "riskcontrol_tags", "fraud_score_reasons", "triggered_rules"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> IssuerFraudView:
        """Create an instance of IssuerFraudView from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in riskcontrol_tags (list)
        _items = []
        if self.riskcontrol_tags:
            for _item in self.riskcontrol_tags:
                if _item:
                    _items.append(_item.to_dict())
            _dict['riskcontrol_tags'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in triggered_rules (list)
        _items = []
        if self.triggered_rules:
            for _item in self.triggered_rules:
                if _item:
                    _items.append(_item.to_dict())
            _dict['triggered_rules'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> IssuerFraudView:
        """Create an instance of IssuerFraudView from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return IssuerFraudView.parse_obj(obj)

        _obj = IssuerFraudView.parse_obj({
            "score": obj.get("score"),
            "risk_level": obj.get("risk_level"),
            "rule_violations": obj.get("rule_violations"),
            "recommended_action": obj.get("recommended_action"),
            "riskcontrol_tags": [RiskcontrolTags.from_dict(_item) for _item in obj.get("riskcontrol_tags")] if obj.get("riskcontrol_tags") is not None else None,
            "fraud_score_reasons": obj.get("fraud_score_reasons"),
            "triggered_rules": [TriggeredRule.from_dict(_item) for _item in obj.get("triggered_rules")] if obj.get("triggered_rules") is not None else None
        })
        return _obj

