# coding: utf-8

"""
    Marqeta Core API

    Simplified management of your payment programs  # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, constr

class KycRequest(BaseModel):
    """
    KycRequest
    """
    notes: Optional[constr(strict=True, max_length=255, min_length=0)] = None
    token: Optional[constr(strict=True, max_length=36, min_length=1)] = None
    user_token: Optional[constr(strict=True, max_length=36, min_length=1)] = Field(None, description="Required if 'business_token' is null")
    business_token: Optional[constr(strict=True, max_length=36, min_length=1)] = Field(None, description="Required if 'user_token' is null")
    manual_override: Optional[StrictBool] = False
    reference_id: Optional[constr(strict=True, max_length=32, min_length=0)] = None
    __properties = ["notes", "token", "user_token", "business_token", "manual_override", "reference_id"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> KycRequest:
        """Create an instance of KycRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> KycRequest:
        """Create an instance of KycRequest from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return KycRequest.parse_obj(obj)

        _obj = KycRequest.parse_obj({
            "notes": obj.get("notes"),
            "token": obj.get("token"),
            "user_token": obj.get("user_token"),
            "business_token": obj.get("business_token"),
            "manual_override": obj.get("manual_override") if obj.get("manual_override") is not None else False,
            "reference_id": obj.get("reference_id")
        })
        return _obj

