# coding: utf-8

"""
    Marqeta Core API

    Simplified management of your payment programs  # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, validator

class MinOffset(BaseModel):
    """
    MinOffset
    """
    unit: Optional[StrictStr] = Field(None, description="specify if a value is provided; default is expiration_offset.unit")
    value: Optional[StrictInt] = Field(None, description="specify if unit is provided; default is expiration_offset.value")
    __properties = ["unit", "value"]

    @validator('unit')
    def unit_validate_enum(cls, v):
        if v is None:
            return v

        if v not in ('YEARS', 'MONTHS', 'DAYS', 'HOURS', 'MINUTES', 'SECONDS'):
            raise ValueError("must be one of enum values ('YEARS', 'MONTHS', 'DAYS', 'HOURS', 'MINUTES', 'SECONDS')")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> MinOffset:
        """Create an instance of MinOffset from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> MinOffset:
        """Create an instance of MinOffset from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return MinOffset.parse_obj(obj)

        _obj = MinOffset.parse_obj({
            "unit": obj.get("unit"),
            "value": obj.get("value")
        })
        return _obj

