# coding: utf-8

"""
    Marqeta Core API

    Simplified management of your payment programs  # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from marqeta_client.models.funding import Funding
from marqeta_client.models.offer_model import OfferModel
from marqeta_client.models.offer_order_aggregated_balances import OfferOrderAggregatedBalances
from marqeta_client.models.offer_order_balances import OfferOrderBalances

class OfferOrderResponse(BaseModel):
    """
    OfferOrderResponse
    """
    created_time: datetime = Field(..., description="yyyy-MM-ddTHH:mm:ssZ")
    last_modified_time: datetime = Field(..., description="yyyy-MM-ddTHH:mm:ssZ")
    user_token: Optional[StrictStr] = None
    business_token: Optional[StrictStr] = None
    token: StrictStr = ...
    order_balances: OfferOrderBalances = ...
    order_aggregated_balances: OfferOrderAggregatedBalances = ...
    funding: Optional[Funding] = None
    offer: Optional[OfferModel] = None
    last_transaction_date: datetime = Field(..., description="yyyy-MM-ddThh:mm:ssZ")
    __properties = ["created_time", "last_modified_time", "user_token", "business_token", "token", "order_balances", "order_aggregated_balances", "funding", "offer", "last_transaction_date"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> OfferOrderResponse:
        """Create an instance of OfferOrderResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of order_balances
        if self.order_balances:
            _dict['order_balances'] = self.order_balances.to_dict()
        # override the default output from pydantic by calling `to_dict()` of order_aggregated_balances
        if self.order_aggregated_balances:
            _dict['order_aggregated_balances'] = self.order_aggregated_balances.to_dict()
        # override the default output from pydantic by calling `to_dict()` of funding
        if self.funding:
            _dict['funding'] = self.funding.to_dict()
        # override the default output from pydantic by calling `to_dict()` of offer
        if self.offer:
            _dict['offer'] = self.offer.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> OfferOrderResponse:
        """Create an instance of OfferOrderResponse from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return OfferOrderResponse.parse_obj(obj)

        _obj = OfferOrderResponse.parse_obj({
            "created_time": obj.get("created_time"),
            "last_modified_time": obj.get("last_modified_time"),
            "user_token": obj.get("user_token"),
            "business_token": obj.get("business_token"),
            "token": obj.get("token"),
            "order_balances": OfferOrderBalances.from_dict(obj.get("order_balances")) if obj.get("order_balances") is not None else None,
            "order_aggregated_balances": OfferOrderAggregatedBalances.from_dict(obj.get("order_aggregated_balances")) if obj.get("order_aggregated_balances") is not None else None,
            "funding": Funding.from_dict(obj.get("funding")) if obj.get("funding") is not None else None,
            "offer": OfferModel.from_dict(obj.get("offer")) if obj.get("offer") is not None else None,
            "last_transaction_date": obj.get("last_transaction_date")
        })
        return _obj

