# coding: utf-8

"""
    Marqeta Core API

    Simplified management of your payment programs  # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr, constr

class PeerTransferRequest(BaseModel):
    """
    PeerTransferRequest
    """
    token: Optional[constr(strict=True, max_length=36, min_length=1)] = None
    amount: Union[StrictFloat, StrictInt] = ...
    tags: Optional[constr(strict=True, max_length=255, min_length=1)] = None
    memo: Optional[constr(strict=True, max_length=99, min_length=1)] = None
    sender_user_token: Optional[constr(strict=True, max_length=36, min_length=1)] = Field(None, description="Required if 'send_business_token' is null")
    recipient_user_token: Optional[constr(strict=True, max_length=36, min_length=1)] = Field(None, description="Required if 'recipient_business_token' is null")
    sender_business_token: Optional[constr(strict=True, max_length=36, min_length=1)] = Field(None, description="Required if 'send_user_token' is null")
    recipient_business_token: Optional[constr(strict=True, max_length=36, min_length=1)] = Field(None, description="Required if 'recipient_business_token' is null")
    currency_code: StrictStr = ...
    __properties = ["token", "amount", "tags", "memo", "sender_user_token", "recipient_user_token", "sender_business_token", "recipient_business_token", "currency_code"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PeerTransferRequest:
        """Create an instance of PeerTransferRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PeerTransferRequest:
        """Create an instance of PeerTransferRequest from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return PeerTransferRequest.parse_obj(obj)

        _obj = PeerTransferRequest.parse_obj({
            "token": obj.get("token"),
            "amount": obj.get("amount"),
            "tags": obj.get("tags"),
            "memo": obj.get("memo"),
            "sender_user_token": obj.get("sender_user_token"),
            "recipient_user_token": obj.get("recipient_user_token"),
            "sender_business_token": obj.get("sender_business_token"),
            "recipient_business_token": obj.get("recipient_business_token"),
            "currency_code": obj.get("currency_code")
        })
        return _obj

