# coding: utf-8

"""
    Marqeta Core API

    Simplified management of your payment programs  # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt, StrictStr, validator

class ProgramReserveTransactionRequest(BaseModel):
    """
    ProgramReserveTransactionRequest
    """
    idempotent_hash: Optional[StrictStr] = Field(None, alias="idempotentHash")
    token: StrictStr = ...
    amount: Union[StrictFloat, StrictInt] = ...
    currency_code: StrictStr = ...
    memo: Optional[StrictStr] = None
    tags: Optional[StrictStr] = None
    type: StrictStr = ...
    is_collateral: Optional[StrictBool] = None
    __properties = ["idempotentHash", "token", "amount", "currency_code", "memo", "tags", "type", "is_collateral"]

    @validator('type')
    def type_validate_enum(cls, v):
        if v not in ('CREDIT', 'DEBIT', 'PENDING_CREDIT', 'PENDING_DEBIT'):
            raise ValueError("must be one of enum values ('CREDIT', 'DEBIT', 'PENDING_CREDIT', 'PENDING_DEBIT')")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ProgramReserveTransactionRequest:
        """Create an instance of ProgramReserveTransactionRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ProgramReserveTransactionRequest:
        """Create an instance of ProgramReserveTransactionRequest from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return ProgramReserveTransactionRequest.parse_obj(obj)

        _obj = ProgramReserveTransactionRequest.parse_obj({
            "idempotent_hash": obj.get("idempotentHash"),
            "token": obj.get("token"),
            "amount": obj.get("amount"),
            "currency_code": obj.get("currency_code"),
            "memo": obj.get("memo"),
            "tags": obj.get("tags"),
            "type": obj.get("type"),
            "is_collateral": obj.get("is_collateral")
        })
        return _obj

