# coding: utf-8

"""
    Marqeta Core API

    Simplified management of your payment programs  # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import List, Optional, Union
from pydantic import BaseModel, StrictFloat, StrictInt, StrictStr, conlist, constr
from marqeta_client.models.fee_detail import FeeDetail
from marqeta_client.models.jit_funding_api import JitFundingApi

class ProgramTransferResponse(BaseModel):
    """
    ProgramTransferResponse
    """
    token: Optional[constr(strict=True, max_length=36, min_length=1)] = None
    type_token: constr(strict=True, max_length=36, min_length=1) = ...
    user_token: Optional[constr(strict=True, max_length=36, min_length=1)] = None
    business_token: Optional[constr(strict=True, max_length=36, min_length=1)] = None
    transaction_token: StrictStr = ...
    currency_code: StrictStr = ...
    amount: Union[StrictFloat, StrictInt] = ...
    memo: Optional[constr(strict=True, max_length=99, min_length=1)] = None
    tags: Optional[constr(strict=True, max_length=255, min_length=1)] = None
    fees: Optional[conlist(FeeDetail)] = None
    created_time: Optional[datetime] = None
    jit_funding: Optional[JitFundingApi] = None
    __properties = ["token", "type_token", "user_token", "business_token", "transaction_token", "currency_code", "amount", "memo", "tags", "fees", "created_time", "jit_funding"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ProgramTransferResponse:
        """Create an instance of ProgramTransferResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in fees (list)
        _items = []
        if self.fees:
            for _item in self.fees:
                if _item:
                    _items.append(_item.to_dict())
            _dict['fees'] = _items
        # override the default output from pydantic by calling `to_dict()` of jit_funding
        if self.jit_funding:
            _dict['jit_funding'] = self.jit_funding.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ProgramTransferResponse:
        """Create an instance of ProgramTransferResponse from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return ProgramTransferResponse.parse_obj(obj)

        _obj = ProgramTransferResponse.parse_obj({
            "token": obj.get("token"),
            "type_token": obj.get("type_token"),
            "user_token": obj.get("user_token"),
            "business_token": obj.get("business_token"),
            "transaction_token": obj.get("transaction_token"),
            "currency_code": obj.get("currency_code"),
            "amount": obj.get("amount"),
            "memo": obj.get("memo"),
            "tags": obj.get("tags"),
            "fees": [FeeDetail.from_dict(_item) for _item in obj.get("fees")] if obj.get("fees") is not None else None,
            "created_time": obj.get("created_time"),
            "jit_funding": JitFundingApi.from_dict(obj.get("jit_funding")) if obj.get("jit_funding") is not None else None
        })
        return _obj

