# coding: utf-8

"""
    Marqeta Core API

    Simplified management of your payment programs  # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, constr

class PushToCardResponse(BaseModel):
    """
    PushToCardResponse
    """
    created_time: datetime = Field(..., description="yyyy-MM-ddTHH:mm:ssZ")
    last_modified_time: datetime = Field(..., description="yyyy-MM-ddTHH:mm:ssZ")
    address_1: Optional[constr(strict=True, max_length=255, min_length=1)] = None
    address_2: Optional[constr(strict=True, max_length=255, min_length=1)] = None
    city: Optional[constr(strict=True, max_length=40, min_length=1)] = None
    state: Optional[constr(strict=True, max_length=2, min_length=1)] = None
    postal_code: Optional[constr(strict=True, max_length=10, min_length=1)] = None
    country: Optional[StrictStr] = None
    last_four: Optional[StrictStr] = None
    token: Optional[constr(strict=True, max_length=36, min_length=1)] = None
    fast_fund_transfer_eligible: Optional[StrictBool] = False
    gambling_fund_transfer_eligible: Optional[StrictBool] = False
    name_on_card: Optional[StrictStr] = None
    last_name: Optional[StrictStr] = None
    exp_date: Optional[StrictStr] = None
    __properties = ["created_time", "last_modified_time", "address_1", "address_2", "city", "state", "postal_code", "country", "last_four", "token", "fast_fund_transfer_eligible", "gambling_fund_transfer_eligible", "name_on_card", "last_name", "exp_date"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PushToCardResponse:
        """Create an instance of PushToCardResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "last_name",
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PushToCardResponse:
        """Create an instance of PushToCardResponse from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return PushToCardResponse.parse_obj(obj)

        _obj = PushToCardResponse.parse_obj({
            "created_time": obj.get("created_time"),
            "last_modified_time": obj.get("last_modified_time"),
            "address_1": obj.get("address_1"),
            "address_2": obj.get("address_2"),
            "city": obj.get("city"),
            "state": obj.get("state"),
            "postal_code": obj.get("postal_code"),
            "country": obj.get("country"),
            "last_four": obj.get("last_four"),
            "token": obj.get("token"),
            "fast_fund_transfer_eligible": obj.get("fast_fund_transfer_eligible") if obj.get("fast_fund_transfer_eligible") is not None else False,
            "gambling_fund_transfer_eligible": obj.get("gambling_fund_transfer_eligible") if obj.get("gambling_fund_transfer_eligible") is not None else False,
            "name_on_card": obj.get("name_on_card"),
            "last_name": obj.get("last_name"),
            "exp_date": obj.get("exp_date")
        })
        return _obj

