# coding: utf-8

"""
    Marqeta Core API

    Simplified management of your payment programs  # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, StrictBool, StrictInt, validator

class SelectiveAuth(BaseModel):
    """
    SelectiveAuth
    """
    sa_mode: Optional[StrictInt] = 1
    enable_regex_search_chain: Optional[StrictBool] = False
    dmd_location_sensitivity: Optional[StrictInt] = 0
    __properties = ["sa_mode", "enable_regex_search_chain", "dmd_location_sensitivity"]

    @validator('sa_mode')
    def sa_mode_validate_enum(cls, v):
        if v is None:
            return v

        if v not in (0, 1, 2):
            raise ValueError("must be one of enum values (0, 1, 2)")
        return v

    @validator('dmd_location_sensitivity')
    def dmd_location_sensitivity_validate_enum(cls, v):
        if v is None:
            return v

        if v not in (0, 1, 2, 3, 4):
            raise ValueError("must be one of enum values (0, 1, 2, 3, 4)")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SelectiveAuth:
        """Create an instance of SelectiveAuth from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SelectiveAuth:
        """Create an instance of SelectiveAuth from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return SelectiveAuth.parse_obj(obj)

        _obj = SelectiveAuth.parse_obj({
            "sa_mode": obj.get("sa_mode") if obj.get("sa_mode") is not None else 1,
            "enable_regex_search_chain": obj.get("enable_regex_search_chain") if obj.get("enable_regex_search_chain") is not None else False,
            "dmd_location_sensitivity": obj.get("dmd_location_sensitivity") if obj.get("dmd_location_sensitivity") is not None else 0
        })
        return _obj

