# coding: utf-8

"""
    Marqeta Core API

    Simplified management of your payment programs  # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, constr

class TokenRequest(BaseModel):
    """
    TokenRequest
    """
    token: Optional[constr(strict=True, max_length=36, min_length=1)] = None
    user_token: Optional[constr(strict=True, max_length=36, min_length=1)] = Field(None, description="required if 'business_token' is null")
    business_token: Optional[constr(strict=True, max_length=36, min_length=1)] = Field(None, description="required if 'user_token' is null")
    account_number: StrictStr = ...
    cvv_number: constr(strict=True, max_length=4, min_length=3) = ...
    exp_date: StrictStr = ...
    zip: Optional[StrictStr] = None
    postal_code: Optional[StrictStr] = None
    is_default_account: Optional[StrictBool] = False
    __properties = ["token", "user_token", "business_token", "account_number", "cvv_number", "exp_date", "zip", "postal_code", "is_default_account"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TokenRequest:
        """Create an instance of TokenRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TokenRequest:
        """Create an instance of TokenRequest from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return TokenRequest.parse_obj(obj)

        _obj = TokenRequest.parse_obj({
            "token": obj.get("token"),
            "user_token": obj.get("user_token"),
            "business_token": obj.get("business_token"),
            "account_number": obj.get("account_number"),
            "cvv_number": obj.get("cvv_number"),
            "exp_date": obj.get("exp_date"),
            "zip": obj.get("zip"),
            "postal_code": obj.get("postal_code"),
            "is_default_account": obj.get("is_default_account") if obj.get("is_default_account") is not None else False
        })
        return _obj

