# coding: utf-8

"""
    Marqeta Core API

    Simplified management of your payment programs  # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, constr

class UserValidationRequest(BaseModel):
    """
    UserValidationRequest
    """
    birth_date: Optional[datetime] = Field(None, description="yyyy-MM-dd")
    phone: Optional[constr(strict=True, max_length=255, min_length=0)] = Field(None, description="Phone #")
    ssn: Optional[constr(strict=True, max_length=255, min_length=0)] = Field(None, description="Last four digits of SSN")
    random_name_line1_postfix: Optional[constr(strict=True, max_length=6, min_length=6)] = Field(None, description="Six-char random name postfix")
    __properties = ["birth_date", "phone", "ssn", "random_name_line1_postfix"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UserValidationRequest:
        """Create an instance of UserValidationRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UserValidationRequest:
        """Create an instance of UserValidationRequest from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return UserValidationRequest.parse_obj(obj)

        _obj = UserValidationRequest.parse_obj({
            "birth_date": obj.get("birth_date"),
            "phone": obj.get("phone"),
            "ssn": obj.get("ssn"),
            "random_name_line1_postfix": obj.get("random_name_line1_postfix")
        })
        return _obj

